#!/usr/bin/python3

import re
import os
import sys
debug = True

lines = sys.stdin.readlines()
lemma = sys.argv[1]

# INPUT:
# - lines contain a list of "%i:goal" where "%i" is the index of the goal
# - lemma contain the name of the lemma under scrutiny
# OUTPUT:
# - (on stdout) a list of ordered index separated by EOL

rank = []             # list of list of goals, main list is ordered by priority
maxPrio = 110
for i in range(0,maxPrio):
  rank.append([])
#Rank 0 is highest

if lemma[0:11]=="functional_" or lemma[0:11]=="executable_":
  for line in lines:
    num = line.split(':')[0]
    if re.match(".*Register_Report.*", line):
      rank[0].append(num)
    elif re.match('.*!KU(~kcol)', line) or re.match('.*!KU(~kauth)', line) or re.match('.*!KU(~kattest)', line): 
      rank[1].append(num)
    elif re.match('.*(at.* = zeroo).*(at.* = onee).*', line): 
      rank[2].append(num)
    elif re.match('.*St_.*', line): 
      if re.match('.*St_V_2.*', line):
        rank[3].append(num)
      if re.match('.*St_V.*', line):
        rank[4].append(num)
      if re.match('.*St_P_s.*', line):
        rank[5].append(num)
      if re.match('.*St_P_r_1.*', line):
        rank[6].append(num)
      if re.match('.*St_P_c.*', line):
        rank[7].append(num)
      if re.match('.*St_P_2.*', line):
        rank[8].append(num)
      if re.match('.*St_P_1.*', line):
        rank[9].append(num)
      if re.match('.*St_P.*', line):
        rank[10].append(num)
    else:
      rank[109].append(num)
elif lemma[0:8]=="correct_":
  for line in lines:
    num = line.split(':')[0]
    if re.match(".*Register_Report.*", line):
      rank[0].append(num)
    elif re.match('.*!KU(~kcol)', line) or re.match('.*!KU(~kauth)', line) or re.match('.*!KU(~kattest)', line): 
      rank[1].append(num)
    elif re.match('.*St_.*', line): 
      rank[2].append(num)
    else:
      rank[109].append(num)
else:
  exit(0)

for listGoals in rank:
  for goal in listGoals:
    print (goal)
